#pragma once

#include "stacktrace.h"
#include <signal.h>

// NOTE: if this file is included somewhere else in the project, linker will fail claiming
// multiple definition of this function
void *__cxa_allocate_exception(size_t n) {
    void *(*orig__cxa_allocate_exception)(size_t) =
        (void *(*)(long unsigned int))dlsym(RTLD_NEXT, "__cxa_allocate_exception");
    stacktrace::print("EXCEPTION!", 2);
    return orig__cxa_allocate_exception(n);
}

// NOTE: if this file is included somewhere else in the project, linker will fail claiming
// multiple definition of this function
void dbg_helper_signal_handler(int signo) {
    if (SIGALRM == signo) {
        stacktrace::print("TIMEOUT: see stacktrace", 3);
    } else {
        stacktrace::print("FATAL SIGNAL: " + std::to_string(signo), 3);
    }
    usleep(100000);
    if (SIGALRM == signo) {
        signo = SIGABRT;
    }

    // FIXME change it for more correct handling (it might be not a SIG_DFL action expected)
    signal(signo, SIG_DFL);
    raise(signo);
}

struct dbg_helper {
    enum mode_t { SIGHANDLERS=1, GDB=2, TIMER=4 };
    void start(int flags, unsigned seconds = 10) {
        if (flags & SIGHANDLERS) {
            signal(SIGSEGV, dbg_helper_signal_handler);
            signal(SIGILL, dbg_helper_signal_handler);
            signal(SIGBUS, dbg_helper_signal_handler);
            signal(SIGFPE, dbg_helper_signal_handler);
            signal(SIGABRT, dbg_helper_signal_handler);
        }
        if ((flags & TIMER) && seconds) {
            signal(SIGALRM, dbg_helper_signal_handler);
            alarm(seconds);
        }
    }
};

