#!/bin/bash

while true; do
    [ -e .jobid ] || { sleep 1; continue; }
    [ "$(cat .jobid)" == 0 ] && { sleep 1; continue; }
    jobid=$(cat .jobid)
    echo "Job: $jobid"
    break
done

#SLURM_JOB_NUM_NODES
#NumNodes: nnodes=$(squeue -j $jobid -O NumNodes | tail -n1)

nnodes=$(squeue -j $jobid -O NumNodes | tail -n1)

srun --overlap --jobid=$jobid -w $(cat .nodelist) --gpus-per-node=8 --nodes=$nnodes --ntasks-per-node=8 --cpu-bind=no --output=out.$jobid.%t --error=err.$jobid.%t --input=none ./lumi-g-test.sh
